package edu.kit.ipd.descartes.adaptation.evaluation.weightingfunction;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotSame;

import java.util.Random;

import org.junit.Before;
import org.junit.Test;

import edu.kit.ipd.descartes.adaptation.evaluation.weightingfunction.IWeightingFunctionCalculator;
import edu.kit.ipd.descartes.adaptation.evaluation.weightingfunction.RandomWeightCalculator;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationFactory;
import edu.kit.ipd.descartes.mm.adaptation.WeightedTactic;

public class RandomWeightCalculatorTest {
	
	IWeightingFunctionCalculator randomCalculator = new RandomWeightCalculator();
	WeightedTactic wt = null;

	@Before
	public void setUp() throws Exception {
		wt = AdaptationFactory.eINSTANCE.createWeightedTactic();
		wt.setName("TestTactic");
		wt.setId("testTacticTestId");
		wt.setCurrentWeight(1.0);
		wt.setDefaultWeight(0.0);
	}

	@Test
	public void testCalculateWeight() {
		Random r = new Random(System.currentTimeMillis());
		assertEquals(r.nextDouble(), randomCalculator.calculateWeight(wt),1.0);
		assertEquals(0.0, wt.getDefaultWeight(), 0.0);
	}

	@Test
	public void testCalculateAndSetWeight() {
		randomCalculator.updateWeight(wt);
		
		assertNotSame(1.0, wt.getCurrentWeight());
		assertEquals(0.0, wt.getDefaultWeight(), 0.0);
	}

}
